// vector2.cc 

#include "vector.h"
#include "fields.h"

template <class T>
T polcontent(const Vector<T>& f)
  {return (f.poldeg()<0)?0:1;}
/*
bigrational polcontent(const Vector<bigrational>& f)
  {return (f.poldeg()<0)?0:1;}
algnum polcontent(const Vector<algnum>& f)
  {return (f.poldeg()<0)?0:1;}
ffield_element polcontent(const Vector<ffield_element>& f)
  {return (f.poldeg()<0)?0:1;}
charmod polcontent(const Vector<charmod>& f)
  {return (f.poldeg()<0)?0:1;}
bigcomplex polcontent(const Vector<bigcomplex>& f)
  {return (f.poldeg()<0)?bigcomplex(0):bigcomplex(1);}
intmod polcontent(const Vector<intmod>& f)
  {return (f.poldeg()<0)?0:1;}
*/

typedef polynomial<bigrational> polbigrat;

template <> 
polbigrat
polcontent(const Vector<polbigrat>& f) 
{
    if(f.poldeg()<0) return polbigrat(0);
    polbigrat g=f[1];
    for(int i=2;i<=f.size();i++)
	g=gcd(g,f[i]);
    return g;
}

template <>
int
polcontent(const Vector<int>& f) 
{
    if(f.poldeg()<0) return 0;
    int g=f[1];
    for(int i=2;i<=f.size();i++)
	g=gcd((long)g,(long)f[i]);
    return g;
}

template <>
bigint
polcontent(const Vector<bigint>& f) 
{
    if(f.poldeg()<0) return 0;
    bigint g=f[1];
    for(int i=2;i<=f.size();i++)
	g=gcd(g,f[i]);
    return g;
}


